const users = [];

// addUser, removeUser, getUser, getUsersInRoom

const addUser = ({ id, username, room }) => {
    // Clean the data
    // username = username.trim().toLowerCase();
    // room = room.trim().toLowerCase();
    if (!room || !username)
        return {
            error: 'Username and room are required',
        };
    // Check for existing user
    const existingUser = users.find((user) => {
        return user.room === room && user.username === username;
    });
    // Validate username
    if (existingUser)
        return {
            error: 'Username is in use!',
        };

    // Store user
    const user = { id, username, room };
    users.push(user);
    return { user };
};

const removeUser = (id) => {
    const index = users.findIndex((user) => user.id === id);
    if (index !== -1) {
        // console.log(users[id])
        return users.splice(index, 1)[0];
    }
};

const getUser = (id) => {
    const foundUser = users.find((user) => user.id === id);
    if (!foundUser) return undefined;
    return foundUser;
};

const getUsersInRoom = (room) => {
    const usersInRoom = users.filter((user) => user.room === room);
    if (!usersInRoom) return [];
    return usersInRoom;
};

module.exports = {
    addUser,
    removeUser,
    getUser,
    getUsersInRoom,
};
